//
// C++ Interface: BNCwithHC
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

// Binary Network Clasiffier with Hamming Clustering
#ifndef BNCWITHHC_H
#define BNCWITHHC_H

#include <iostream>
#include "BinaryNetwork.h"
#include "BinaryNetworkClassifier.h"
#include "Parameters.h"
#include "Model.h"

using namespace std;

class BNCwithHC :  public Classifier
{
    BinaryNetworkClassifier *finalBNC;
    
protected:
    struct network_parameters params;
public:
    
    BNCwithHC();

    void Configure(Parameters &p);
    void Learn(Data *d);
    Label Test(float *vector);
    float TrainError();
    void Save(char *file);
    void Load(char *file);
    void Reset();
    
    ~BNCwithHC();
    
	friend ostream& operator<<(ostream& o,BNCwithHC &bnet)
	{
     		 o << (BinaryNetwork&)bnet.finalBNC;
		return o;
	}



};


#endif