//
// C++ Interface: BinaryMLP
//
// Description:
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __BINARYMLP_H
#define __BINARYMLP_H

#include <iostream>
#include "BinaryNetwork.h"
#include "Parameters.h"
#include "Model.h"

using namespace std;
// siec klasyfikujaca uczaca sie wyjscia 0,1 (problemy binarne, dwuklasowe), w celu uczenia problemow dwuklasowych z innymi labelkami uzyj sieci BinaryNetworkClasifier (w przyszlosci bedzie to polaczone)
// mozna uzywac w kroswalidacji i Xtescie
class BinaryMLP : public BinaryNetwork, public Classifier
{
protected:
    struct network_parameters params;
    int output_number;                     ///< okresla ktora z klas (etykiet) ma byc uczana
    
 //   Network net;
public:
    
    BinaryMLP();

    void Configure(Parameters &p);
    void Learn(Data *d);
    Label Test(float *vector);
    float TrainError();
    void Save(char *file);
    void Load(char *file);
	 float GetValueOf(char *);
	 void DisplayModel()
	 {
	 		cout << *this;
	 }
    
	 void Reset();
    
    ~BinaryMLP();
    
	friend ostream& operator<<(ostream& o,BinaryMLP &knet)
	{
      		o << (BinaryNetwork&)knet;
		return o;
	}
};
#endif
