//
// C++ Implementation: BinaryNetworkClassifier
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "BinaryNetworkClassifier.h"

BinaryNetworkClassifier::BinaryNetworkClassifier( )
{
    model_name = "BinaryNetworkClassifier";
    output_number = 1;
    treshold = 0.5;
    labels[0]=1;
    labels[1]=0;
}

void BinaryNetworkClassifier::Configure( Parameters & p )
{
//   params = p;
   ((BinaryNetwork*)this)->Configure(p);
}

void BinaryNetworkClassifier::Learn( Data * d )
{
    labels[0]=d->labelsInfo->GetLabel(0);
    labels[1]=d->labelsInfo->GetLabel(1);
    Run(d);
}

float BinaryNetworkClassifier::TrainError( )
{
        return t_info.mseError;
}

Label BinaryNetworkClassifier::Test( float * vector )
{
    CalculateActivation( vector );
//    return (GetActivation( 0 ) >= treshold)? 1.0 : 0.0 ;
    return (GetActivation( 0 ) >= treshold)? labels[1] : labels[0] ;
}

void BinaryNetworkClassifier::Save( char * file )
{
}

void BinaryNetworkClassifier::Load( char * file )
{
}

void BinaryNetworkClassifier::Reset( )
{
//    if (is_created) ((BinaryNetwork *)this)->Reset();
    ((Network *)this)->Reset();
    ((Network *)this)->Clear();
 //   params = init_param;
 //   cout << "Reset :" << init_param.learning_rate << endl;
}



BinaryNetworkClassifier::~ BinaryNetworkClassifier( )
{
}


float BinaryNetworkClassifier::GetValueOf(char *)
{
	return this->NumberOfNeurons();	
}
