//
// C++ Interface: BinaryMLP
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __BINARY_NETWORK_CLASSIFIER_H
#define __BINARY_NETWORK_CLASSIFIER_H

#include <iostream>
#include "BinaryNetwork.h"
#include "Parameters.h"
#include "Model.h"

using namespace std;

class BinaryNetworkClassifier : public BinaryNetwork, public Classifier
{

Label labels[2];
protected:
    struct network_parameters params;
    int output_number;                     ///< okresla ktora z klas (etykiet) ma byc uczana    
 //   Network net;
public:
    
    BinaryNetworkClassifier();

    void Configure(Parameters &p);
    void Learn(Data *d);
    Label Test(float *vector);
    float TrainError();
    void Save(char *file);
    void Load(char *file);
	 float GetValueOf(char *);
    void Reset();
    
    ~BinaryNetworkClassifier();
    
	friend ostream& operator<<(ostream& o,BinaryNetworkClassifier &knet)
	{
      o << (BinaryNetwork&)knet;
		return o;
	}
};
#endif
