#include "Data.h"

using namespace std;

Data::Data()
{
	is_a_copy=0;
	number_of_signal_vectors=number_of_features=0;
   signal=NULL;
   data_name = NULL;
	dstat=NULL;
	labelsInfo = new LabelsReprezentation();
}

Data::Data(const Data &d)
{
	//ClearDataSet();
	is_a_copy=1;
	dstat=d.dstat;
	number_of_signal_vectors=d.number_of_signal_vectors;
   number_of_features=d.number_of_features;
   number_of_outputs=d.number_of_outputs;
// 	labelsInfo = new LabelsReprezentation();
/*   labelsInfo->Copy(d.labelsInfo);
	number_of_features=d.number_of_features;*/
    
    labelsInfo=d.labelsInfo;
	signal = new Vector[number_of_signal_vectors];
	if(!signal) throw new MemoryException("dataset not created");

	for(unsigned long i=0;i<number_of_signal_vectors;i++)
	{
			signal[i]=d.signal[i];
	}
    
//    RefreshDataInfo();
    data_name="Copy of data";
}


Data::~Data()
{
	if(!is_a_copy)
		ClearDataSet();
	delete [] signal;
	signal=NULL;
}

void Data::ClearDataSet()
{
    if(signal)
    {
        for(unsigned long i=0;i<number_of_signal_vectors;i++)
        {
			if(signal[i])
			{
				if(signal[i]->InputS)
				{
					delete signal[i]->InputS;
					signal[i]->InputS=NULL;
				}

	//			if(signal[i]->OutputS)
	//			{
		//			delete signal[i]->OutputS;
					signal[i]->OutputS=NULL;
		//		}
				delete signal[i];
				signal[i]=NULL;
			}
		}
		
//		labelsInfo->Clear();
      delete labelsInfo;
      labelsInfo = NULL;
     
	}

   
   if(dstat) 
   {
        delete [] dstat;
        dstat=NULL;
    }

	//if (data_name) delete [] data_name;

    number_of_signal_vectors=number_of_features=0;
    data_name = NULL;
}


/* czyta plik data.pat i data.div
 wczytuje dane i zlicza ilosc wektorow w kazdej z klas */
void Data::ReadData(char *file_name)
{

    ReadData(file_name,raw);
 }

int Data::CheckDataFile(ifstream &file,data_format f)
{
    file.seekg(0,ios::beg);
    float tmp=0;
    unsigned long atrrNumber = 0;
    char a=0;
    number_of_features = 0;
    number_of_signal_vectors = 0;
    number_of_outputs = 0;
    
    if(f==sca)
    {
        file >> number_of_features;
        file >> number_of_outputs;
        atrrNumber = number_of_features + number_of_outputs;
        
        unsigned long i=0;
        long lineNumber=0;

        while(!file.eof() && file.good())
        {
            lineNumber++;
            for(i=0;i<atrrNumber && file.good();i++)
                file >> tmp;
                    
            if(file.eof()) break;

            if(!(file.peek()=='\n' || file.peek()=='\r'))
            {
                cerr << "Cos nie tak w linii " << lineNumber << endl;
                return 0;
            }
        }
       number_of_signal_vectors = lineNumber-1;
        return 1;
    }
    
    if(f==raw)
    {
        while((a=file.peek())!='\n' && a!='\r' && file.good() )
        {
            file >> tmp;
            atrrNumber++;
        }
    
        if(atrrNumber == 0)
        {
            cerr << "Number of number_of_features is 0 !!! \n";
            return 0;
        }
    
        //ustalam liczbe wektorow liczac iosc linii w pliku
        unsigned long i=0;
        long lineNumber=0;
        file.seekg(0,ios::beg);

        while(!file.eof() && file.good())
        {
            lineNumber++;
            for(i=0;i<atrrNumber && file.good();i++)
                file >> tmp;
                
            if(file.eof()) break;
    
            if(!(file.peek()=='\n' || file.peek()=='\r') || i < number_of_features)
            {
                cerr << "Cos nie tak w linii " << lineNumber << endl;
                return 0;
            }
        }

        number_of_features = atrrNumber-1;
        number_of_signal_vectors = lineNumber-1;
    
        return 1;
    }
}

void Data::Save( char * file_name, data_format f )
{
    ofstream file_out;
    file_out.open(file_name);
    if(!file_out) throw new FileException(file_name);
    
    SaveData(file_out,f);

    file_out.close();
    

}

void Data::Save(char *filename)
{
    Save(filename,raw);
}


void Data::SaveData( ofstream & o )
{
     for(unsigned long i=0;i<number_of_signal_vectors;i++)
     {
         for(unsigned long j=0;j<number_of_features;j++)
             o << signal[i]->InputS[j] << "\t";
 
         o << signal[i]->classLabel << endl;
     }
 
 }

void Data::SaveData( ofstream & o, data_format f )
{
    if(f==snns) 
    {
        o << "SNNS pattern definition file V1.4\n";
        o << "generated at Tue May 22 12:47:50 2007\n\n";
        o << "No. of patterns     : " << this->number_of_signal_vectors << endl;
        o << "No. of input units  : " << this->number_of_features << endl;
        o << "No. of output units : 1" <<  endl << endl;
    }
    if(f==sca)
    {
        o << this->number_of_features << "\t1\n";
        cerr << "Warning: note that this implementation always save only one output\n";
        cerr << "Remember to add .set extension to dataset file\n";
    }
    SaveData(o);            
}


int Data::GetNrVectorsInClass(int c)
{
    return labelsInfo->GetNumberOfVectorsInClass(c);
}

void Data::DisplayData()
{
    cout << *this;

    for(unsigned long i=0;i<number_of_signal_vectors;i++)
    {
        cout << "[" << i << "]\t";
        for(unsigned long k=0;k<number_of_features;k++)
            cout << signal[i]->InputS[k] << "\t";

        cout << " | ";
        
        int nol = labelsInfo->GetNumberOfLabels();
       
        for(int k=0;k < nol;k++) cout << signal[i]->OutputS[k] << "\t"; cout << "|";
        
        cout << signal[i]->classLabel;
        cout << endl;
    }
}

void Data::CreateDiagonalReprezentationOfLabels()
{
     if(labelsInfo) labelsInfo->Clear();  
     else labelsInfo = new LabelsReprezentation();
     
     Label *labelsTable = new Label[number_of_signal_vectors];
     if(!labelsTable) throw new MemoryException("Diagonal reprezentation error");
     
     for(unsigned long i=0;i<number_of_signal_vectors;i++)
        labelsTable[i]=signal[i]->classLabel;

    labelsInfo->CreateDiagonalReprezentation(labelsTable,number_of_signal_vectors);
    delete [] labelsTable;
    
     for(unsigned long i=0;i<number_of_signal_vectors;i++)
        signal[i]->OutputS = labelsInfo->Label2Output(signal[i]->classLabel);
     number_of_outputs= labelsInfo->GetNumberOfLabels();
}

Data *Data::SelectVectors(BitVector &bitv)
{
	Data *d = new Data();
	if(!d) throw new Exception("there is no data");
	d->is_a_copy=1;
	
   
 	d->number_of_signal_vectors= bitv.Count(1);
	d->number_of_features=number_of_features;
  // d->labelsInfo = labelsInfo;
    
	d->signal = new Vector[d->number_of_signal_vectors];
	if(!d->signal) throw new MemoryException("dataset not created");

	unsigned long k=0;
	for(unsigned long i=0;i<number_of_signal_vectors;i++)
	{
		if(bitv[i]) 
		{
			d->signal[k]=signal[i];
			k++;
		}
	}
	d->number_of_outputs=number_of_outputs;
//	d->CreateDiagonalReprezentationOfLabels();
   d->labelsInfo=labelsInfo;
	d->RefreshDataInfo();
	return d;
}

void Data::DisplayDataInfo( )
{
    cout << *this;
}

void Data::RefreshStatistics()
{
    if (dstat) delete [] dstat;
    dstat = new DataStatistics[this->number_of_features];
    if(!dstat) throw new MemoryException("Memory error at data statistics compiuting");
    
    for(unsigned long i=0;i<number_of_features;i++) 
    {
        dstat[i].max=0;
        dstat[i].min=0;
        dstat[i].mean=0;
        dstat[i].std=0;
        dstat[i].var=0;
    }
    
    float *input=NULL;
    
    for(unsigned long v=0;v<number_of_signal_vectors;v++)
    {
        input = GetInput(v);
        for(unsigned long f=0;f<number_of_features;f++)
            dstat[f].mean+=input[f];
    }
    
    for(unsigned long f=0;f<number_of_features;f++)
    {
        dstat[f].mean/=number_of_signal_vectors;
        dstat[f].min=dstat[f].mean;
        dstat[f].max=dstat[f].mean;
    }

    for(unsigned long v=0;v<number_of_signal_vectors;v++)
    {
        input = GetInput(v);
        for(unsigned long f=0;f<number_of_features;f++)
        {
            if(input[f]<dstat[f].min) dstat[f].min=input[f];
            if(input[f]>dstat[f].max) dstat[f].max=input[f];
            dstat[f].var+=(input[f]-dstat[f].mean)*(input[f]-dstat[f].mean);
        }
    }
    for(unsigned long f=0;f<number_of_features;f++)
    {
        dstat[f].var/=number_of_signal_vectors;
        dstat[f].std=sqrt(dstat[f].var/(number_of_signal_vectors-1));
    }
}

void Data::DisplayStatistics( )
{
    RefreshStatistics();
    
    cout << "mean : ";
    for(unsigned int f=0;f<number_of_features;f++)
    {
        cout << dstat[f].mean << " ";
    }
    cout << endl;

    cout << "min : ";
    for(unsigned int f=0;f<number_of_features;f++)
    {
        cout << dstat[f].min << " ";
    }
    cout << endl;
    cout << "max : ";
    for(unsigned int f=0;f<number_of_features;f++)
    {
        cout << dstat[f].max << " ";
    }
    cout << endl;
    cout << "std : ";
    for(unsigned int f=0;f<number_of_features;f++)
    {
        cout << dstat[f].std << " ";
    }
    cout << endl;
    cout << "var : ";
    for(unsigned int f=0;f<number_of_features;f++)
    {
        cout << dstat[f].var << " ";
    }
    cout << endl;
}

Data * Data::Clone( )
{
    Data *newdata = new Data();
    
    newdata->number_of_features = number_of_features;
    newdata->number_of_signal_vectors = this->number_of_signal_vectors;
     
    newdata->signal=new Vector[number_of_signal_vectors];
	 if(!newdata->signal) throw new MemoryException("dataset not created");

    for(unsigned long i=0;i<number_of_signal_vectors;i++)
    {
        InputData *vector= new InputData;
        if(!vector) throw new MemoryException("dataset not created");
	
         vector->InputS=new float [number_of_features];
         if(!vector->InputS) throw new MemoryException("dataset not created");
         for(unsigned long j=0;j<number_of_features;j++)
             vector->InputS[j] = this->signal[i]->InputS[j];

        vector->OutputS = NULL;
        
        vector->classLabel = this->signal[i]->classLabel;
        newdata->signal[i]=vector;
    }
   newdata->CreateDiagonalReprezentationOfLabels();
  //  newdata->RefreshStatistics();
    newdata->RefreshDataInfo();
    return newdata;
}

void Data::CreateEmptyDataTable( long nr_vec, long nr_feat)
{
    ClearDataSet();
    
    number_of_signal_vectors = nr_vec;
    number_of_features = nr_feat;
    
    signal=new Vector[number_of_signal_vectors];
 	 if(!signal) throw new MemoryException("dataset not created");

    for(unsigned long i=0;i<nr_vec;i++)
    {
        InputData *vector= new InputData;
        if(!vector) throw new MemoryException("dataset not created");
	
        vector->InputS=new float [nr_feat];
        if(!vector->InputS) throw new MemoryException("dataset not created");
        vector->OutputS=NULL;

        for(unsigned long j=0;j<number_of_features;j++)
            vector->InputS[j]=0.0;

        vector->classLabel = 0;
        signal[i]=vector;
        vector=NULL;
    }
}

void Data::RefreshDataInfo( )
{

    ComputeNumberOfVectorsInClasses( );
    RefreshStatistics();
}

void Data::DisplayLabelsInfo( )
{
    ComputeNumberOfVectorsInClasses();
    cout << labelsInfo;
}

void Data::ComputeNumberOfVectorsInClasses( )
{
    int nol = labelsInfo->GetNumberOfLabels();
    
    for(int i=0;i<nol;i++) labelsInfo->SetNumberOfVectors(i,0);
    
    for(int i=0;i<number_of_signal_vectors;i++)
         labelsInfo->IncreaseNumberOfVectors(this->GetLabel(i));           
}





void Data::ReadData(ifstream & in, data_format f)
{
    in.clear();
    in.seekg(0,ios::beg);
    
    int dummy;
    
     if(f == sca )
     {
         Label *outdummy = NULL;
         in >> number_of_features;
         in >> number_of_outputs; 
     }
     
//     ClearDataSet();
     CreateEmptyDataTable( number_of_signal_vectors , number_of_features );
     

     for(unsigned long i=0;i<number_of_signal_vectors;i++)
     {
         for(unsigned long j=0;j<number_of_features;j++)
             in >> signal[i]->InputS[j];
        
        if (f!=sca || number_of_outputs == 1)
        {
            in >> signal[i]->classLabel;
        }
        else
        {
            float outdummy;
            float maxout = -1;
            int label = 0;
            
            for(int k=0;k<number_of_outputs;k++)
            {
                in >> outdummy;
                if(outdummy > maxout) 
                {
                    label = k+1;
                    maxout = outdummy;
                }
            }
            signal[i]->classLabel = (Label)label;
        }
     }
    
    CreateDiagonalReprezentationOfLabels();
    RefreshDataInfo();
}


void Data::ReadData(char * file_name, data_format f)
{
    ifstream file_in,file_div;

    file_in.open(file_name);
    if(!file_in) throw new FileException(file_name);

    data_name = new char[strlen(file_name)+1];
    strcpy(data_name,file_name);

    cout << "\nreding file\n\n";
    if(!CheckDataFile(file_in,f))
    {
        file_in.close();
        exit(1);
    }
    
    ReadData(file_in,f);
    file_in.close();
}

Data * Data::SelectFeatures(BitVector & bitvector)
{
	Data *d = new Data();
	if(!d) throw new Exception("there is no data");
	
	int vectorsCount = this->number_of_signal_vectors;
	int featuresCount = this->number_of_features;
	int newFeaturesCount = bitvector.Count(1);
 	
   d->CreateEmptyDataTable(vectorsCount,newFeaturesCount);
        
	for(unsigned long i=0;i<vectorsCount;i++)
	{
      int k=0;
		for(unsigned long f=0;f<featuresCount;f++)
		{
        if(bitvector[f]) 
        {
            d->signal[i]->InputS[k]=signal[i]->InputS[f];
            k++;
        }
        d->signal[i]->classLabel=signal[i]->classLabel;
      }
	}
	
	 d->CreateDiagonalReprezentationOfLabels();
    d->RefreshDataInfo();
	return d;


}

Data * Data::SelectFeaturesAndVectors(BitVector & vectors,BitVector &features)
{
	Data *d = new Data();
	if(!d) throw new Exception("there is no data");
//	d->is_a_copy =1;
	int vectorsCount = this->number_of_signal_vectors;
	int featuresCount = this->number_of_features;
	int newFeaturesCount = features.Count(1);
 	int newVectorsCount = vectors.Count(1);
 	
   d->CreateEmptyDataTable(newVectorsCount,newFeaturesCount);
   d->labelsInfo->Copy(this->labelsInfo);
        
   int v = 0;
	for(unsigned long i=0;i<vectorsCount;i++)
	{
      if(vectors[i])
      {
        int k=0;
        for(unsigned long f=0;f<featuresCount;f++)
        {
            if(features[f]) 
            {
                d->signal[v]->InputS[k]=signal[i]->InputS[f];
                k++;
            }
            d->signal[v]->classLabel=signal[i]->classLabel;
            d->signal[v]->OutputS=d->labelsInfo->Label2Output(signal[i]->classLabel);
        }
        v++;
      }
	}
	
     
  //   int labels = labelsInfo->GetNumberOfLabels();
/*     Label *lt = new Label[labels];
     int *nt = new int[labels];
     
     for(int i=0;i<labels;i++) 
     {
        lt[i]=labelsInfo->GetLabel(i);
        nt[i]=0;
     }
     d->labelsInfo->CreateDiagonalReprezentation(lt,labels);
     
     for(unsigned long i=0;i<d->number_of_signal_vectors;i++)
     { 
        Label l=d->signal[i]->classLabel;
        int a = d->labelsInfo->Find(l);
        ++nt[a];
        d->signal[i]->OutputS = d->labelsInfo->Label2Output(l);
     }
     for(unsigned long i=0;i<d->number_of_signal_vectors;i++) d->labelsInfo->SetNumberOfVectors(i,nt[i]);*/
     
  //   d->number_of_outputs= labels;
//	 d->CreateDiagonalReprezentationOfLabels();
    d->RefreshDataInfo();
    
//    delete [] lt;
//    delete [] nt;
	return d;


}
