//
// C++ Interface: HammingClustering
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __HAMMING_H
#define __HAMMING_H

#include <iostream>
#include "Model.h"
#include "Data.h"
#include "exceptions.h"
#include "Parameters.h"
#include "BitVector.h"
#include "RandomID.h"

class HammingClustering: public Transformation
{
    BitVector *featureSelection;
    int classToLearn;
    int *iset;                   // zbior indeksow istotnych cech
    int niset;                   // ilosc istotnych cech
    int EqualMask (float *pat1,float *pat2,int *iset,int n);
    int EqualPattern (float *patt1, float *patt2, int n);
    
    public :
        HammingClustering():featureSelection(NULL),classToLearn(1),niset(0),iset(NULL)
            {};
        void Configure(Parameters &p)
            {};
            
        Data* Learn(Data *d);
        Data* Run(Data *d);
        int *GetSelectedFeatures()
        {
            return iset;
        }
        int GetNumbetOfSelectedFeatures()
        {
            return niset;
        }
        ~HammingClustering();
        
        friend ostream& operator<<(ostream &o,HammingClustering &hc)
        {
            o << "Hamming clustering results: ";
            for(int i=0;i<hc.niset ; i++)  o << hc.iset[i] << " ";
                o<< endl;
            return o;
        }
};
#endif
