
#ifndef __KNETWORK_H
#define __KNETWORK_H

#include <iostream>
#include "Network.h"
#include "BinaryNetwork.h"
#include "Parameters.h"
#include "Model.h"

using namespace std;
// siec skladajaca sie z kilku sieci rozwiazujacych problemy binarne
class KNetwork : public Classifier
{
protected:
    struct train_parameters t_param;
    BinaryNetwork *netTable;
    unsigned int nrOfNetworks;
    void CreateKNetwork(Data *data);
    Parameters *init_param;

public:
    
    KNetwork();
//    KNetwork(Data *data);

    void Configure(Parameters &p);
    void ConnectWithData(Data *d);
    void Learn(Data *d);
    Label Test(float *vector);
    float TrainError();
    void Save(char *file);
    void Load(char *file);
    float GetValueOf(char *);
	 void Reset();
    int NumberOfNeurons();
    long GetNumberOfNullConnections(double epsilon);
    ~KNetwork();

	friend ostream& operator<<(ostream& o,KNetwork &knet)
	{
		o << "Nr. of networks: " << knet.nrOfNetworks << endl;
		for(int i=0;i<knet.nrOfNetworks;i++) 
			o << knet.netTable[i];
		return o;
	}
};





#endif
