//
// C++ Implementation: KernelNetwork
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "KernelNetwork.h"
KernelNetwork::KernelNetwork( )
{
    inputFeatures = 0;
}

void KernelNetwork::Configure( Parameters & p )
{
    kernelTrans.Configure( p);
    norm.Configure(p);
    knet.Configure(p);
}

void KernelNetwork::Learn( Data * d )
{
    inputFeatures = d->GetNumberOfFeatures();
    Data *newdata = kernelTrans.Learn( d );
    Data *normdata = norm.Learn( newdata );
    knet.Learn( d);
    
    delete newdata;
    delete normdata;
}

void KernelNetwork::Save( char * flie )
{
    throw new Exception("not implemented - KernwlNetwork->Save");
}

void KernelNetwork::Load( char * flie )
{
    throw new Exception("not implemented - KernwlNetwork->Save");
}

Label KernelNetwork::Test( float * v )
{
    Data *testData = new Data();
    testData->CreateEmptyDataTable( 1 , inputFeatures );
    float *input = testData->GetInput( 0 );
    for(int i=0;i<inputFeatures;i++) input[i]=v[i];
    testData->CreateDiagonalReprezentationOfLabels(); //????? 
    testData->RefreshDataInfo();
    testData->DisplayData();
    testData->DisplayDataInfo();
    testData->DisplayStatistics();
    
    Data *newdata = kernelTrans.Run( testData );
    Data *normdata = norm.Learn( newdata );
    Label out = knet.Test( normdata->GetInput( 0 ));
    delete newdata;
    delete normdata;
    delete testData;
    return out;
}

void KernelNetwork::Reset( )
{
    knet.Reset();
    norm.Reset();
    kernelTrans.Reset();
}

