#include "Parameters.h"

void Parameters::ParseArguments(int argc, char **argv)
{
    int i=1;
    while(i<argc)
    {
        char *ap=argv[i];
        //floatingpoint parameters
        if (!strcmp(ap,"-lr") || !strcmp(ap,"--learning-rate"))
                learning_rate = atof(argv[++i]);
        else if (!strcmp(ap,"-rf") || !strcmp(ap,"--reward-factor"))
                reward_factor = atof(argv[++i]);
        else if (!strcmp(ap,"-pf") || !strcmp(ap,"--penalty-factor"))
                penalty_factor = atof(argv[++i]);
        else if (!strcmp(ap,"-lf") || !strcmp(ap,"--lambda-factor"))
                lambda_factor =  atof(argv[++i]);
        else if (!strcmp(ap,"-r") || !strcmp(ap,"--regularization"))
                regularization = atof(argv[++i]);
        else if (!strcmp(ap,"-s") || !strcmp(ap,"--slope"))
                slope = atof(argv[++i]);
        else if (!strcmp(ap,"--diffusion"))
                diffusion = atof(argv[++i]);
		  else if (!strcmp(ap,"-eps"))
			  eps = atof(argv[++i]);

		  
        //integer parameters
        else if (!strcmp(ap,"-n") || !strcmp(ap,"--hidden-neurons"))
                initial_nr_of_hidden_neurons = atoi(argv[++i]);
        else if (!strcmp(ap,"-ni") || !strcmp(ap,"--number-of-initiatializations"))
                number_of_initiatializations = atoi(argv[++i]);
        else if (!strcmp(ap,"-na") || !strcmp(ap,"--number-of-attempts"))
                number_of_attempts = atoi(argv[++i]);
        else if (!strcmp(ap,"-i") || !strcmp(ap,"--iterations"))
                 max_nr_of_iterations= atoi(argv[++i]);
        else if (!strcmp(ap,"-dim"))
                dim=atoi(argv[++i]);
        else if (!strcmp(ap,"-cv") || !strcmp(ap,"--crossvalidation-folds"))
                 nr_cv = atoi(argv[++i]);
        else if (!strcmp(ap,"--crossvalidation-method"))
        {
            if(!strcmp(argv[i+1],"random")) cv_method=monte_carlo;
            if(!strcmp(argv[i+1],"stratified")) cv_method=stratified;
            i++;		
        }
    
        else if (!strcmp(ap,"-nt") || !strcmp(ap,"--number-of-tests"))
            nr_test = atoi(argv[++i]);
        
        else if(!strcmp(ap,"--nhidden"))
            hidden_neurons_count = atoi(argv[++i]);
        
        else if (!strcmp(ap,"--train")||!strcmp(ap,"-input"))
            train_file=argv[++i];
        else if (!strcmp(ap,"--test"))
            test_file=argv[++i];
        
        else if (!strcmp(ap,"--slope-learning"))
            slope_learning = atoi(argv[++i]);

        
        else if (!strcmp(ap,"--data-type"))
        {
            if(!strcmp(argv[i+1],"table")) datatype = table_with_labels;
            if(!strcmp(argv[i+1],"list")) datatype = list_of_ints;
            if(!strcmp(argv[i+1],"generate")) datatype = generated;
            
            i++;		
        }
      
        else if (!strcmp(ap,"--format")||!strcmp(ap,"-f"))
        {
            if(!strcmp(argv[i+1],"snns")) d_format = snns;
            if(!strcmp(argv[i+1],"sca")) d_format = sca;
            i++;
        }

        else if (!strcmp(ap,"--input")||!strcmp(ap,"--hidden")||!strcmp(ap,"--output"))
        {
            neuron_type t;
            if(!strcmp(argv[i+1],"linear")) t = linear;
            if(!strcmp(argv[i+1],"sigmoid")) t = sigmoid;
            if(!strcmp(argv[i+1],"ssigmoid")) t = ssigmoid;
            if(!strcmp(argv[i+1],"bicentral")) t = bicentral;
            if (!strcmp(ap,"--input")) input =t;
            if(!strcmp(ap,"--hidden")) hidden =t;
            if(!strcmp(ap,"--output")) output = t;
            i++;		
        }
        
        else if (!strcmp(ap,"--transformation"))
        {
            if(!strcmp(argv[i+1],"none")) trans = none;
            if(!strcmp(argv[i+1],"standarization")) trans = standarization;
            if(!strcmp(argv[i+1],"normalization")) trans = normalization;
            if(!strcmp(argv[i+1],"binarization")) trans = binarization;
            i++;
        }
        else if (!strcmp(ap,"--init-type"))
        {
            if(!strcmp(argv[i+1],"random")) initiation = _rand;
            if(!strcmp(argv[i+1],"copy")) initiation = _copy;
            i++;
        }      
  	else if (!strcmp(ap,"--network-type"))
        {
            if(!strcmp(argv[i+1],"binary")) networkType = bNet;
            if(!strcmp(argv[i+1],"knetwork")) networkType = kNet;
            if(!strcmp(argv[i+1],"mlp")) networkType = MLP;
            i++;		
        }
  
        //flags
        else if (!strcmp(ap,"--static")) strategy_of_learning=static_network;
        else if (!strcmp(ap,"-v")) debug_level=1;
        else if (!strcmp(ap,"-vv")) debug_level=2;
        else if (!strcmp(ap,"-vvv")) debug_level=3;
        else if (!strcmp(ap,"-vvvv")) debug_level=4;
        else if (!strcmp(ap,"--grow")) strategy_of_learning= grow;
        else if (!strcmp(ap,"--selection")) vector_selection=true;
        else if (!strcmp(ap,"-H")||!strcmp(ap,"--hamming")) hammingClustering=true;
        else if (!strcmp(ap,"--unfreeze")) freezOutput=false;
        else if (!strcmp(ap,"-h") || !strcmp(ap,"--help"))
        {
            Usage();
            exit(0);
        }
        else
        {
                cout << "Parametr " << ap << " nieobslugiwany\n";
                Usage();
                exit(1);
        }
        i++;
    }
	 if (networkType == MLP )
	 {
	 	reward_factor=0.0;
		penalty_factor=0.0;
		network_architecture=static_network;
		freezOutput = 0;
	 }
}

void Parameters::DisplayParameters()
{
    cout << "Initial value of learning rate     \t" << learning_rate << endl;
    cout << "Reward factor                      \t" << reward_factor << endl;
    cout << "Penalty factor                     \t" << penalty_factor << endl;
    cout << "Lambda factor                       \t" << lambda_factor << endl;
    cout << "Regularization                      \t" << regularization << endl;
	 cout << "Eps                                 \t" << eps << endl;
    cout << "No. of hidden neurons               \t" << initial_nr_of_hidden_neurons << endl;
    cout << "Max. number of iterations           \t" << max_nr_of_iterations << endl;
    cout << "Max. number of initializations      \t" << number_of_initiatializations << endl;
    cout << "Initial slope of sigmoid function   \t" << slope << endl;
    cout << "Initiation type                     \t";
    if(initiation == _rand) cout << "random [-1,1]" << endl;
        else cout << "copy weight from previous node " << endl;
    cout << "slope learning                      \t" ;
    if (slope_learning == 0 ) cout << "none\n";
    else if(slope_learning == 1 ) cout << "gradient\n";
    else if(slope_learning == 2 ) cout << "ukierunkowany gradient\n";
    cout << "Remove learned instances            \t" << vector_selection << endl;
    cout << "Hamming Clustering                  \t" << hammingClustering << endl;
    
    cout << "Network architecture                \t";
    if(network_architecture==static_network) cout << "static\n"; else cout << "grow\n";

   cout << "Network type                         \t";
   if(networkType == bNet) cout << "Binary Network\n";
   else if (networkType == kNet) cout << "K Binary Networks\n";
   else if (networkType == MLP) cout << "MultiLayer Perceptorn\n";
   else cout << "Unknown Network Type\n";

   cout << "Hidden neurons type                   \t";
   if(hidden == linear) cout << "linear\n";
   else if (hidden == sigmoid) cout << "sigmoid\n";
   else if (hidden == bicentral) cout << "bicentral\n";
   else if (hidden == ssigmoid) cout << "magic (two sigmoids)\n";

   cout << "Output neurons type                   \t";
   if(output == linear) cout << "linear";
   else if (output == sigmoid) cout << "sigmoid";
   else if (output == bicentral) cout << "bicentral";
   else if (output == ssigmoid) cout << "magic (two sigmoids)";

   if (freezOutput) cout << " [frozen]\n"; else cout << endl;

   if(datatype == table_with_labels )
   {
        if(train_file!=NULL)   cout << "Training file                    \t" << train_file << endl;
   }else if(datatype == list_of_ints )
   {
	cout << "Boolean functions file             \t" << train_file << endl;
	cout << "Dim. of boolean functions          \t" << dim << endl;
   }else if(datatype == generated) cout << "Training file             \t generated"  << endl;
   else 
   {
        if(train_file != NULL )		cout << "Training file                          \t" << train_file << endl;
        if(test_file != NULL )		cout << "Test file                              \t" << test_file << endl;
   }
//  		cout << "Nr. of tests                           \t" << nr_test << endl;
//  		if(test_file)	cout << "Test file                          \t" << test_file << endl;
//  		else
//  		{
//  			cout << "Nr. of crossvalidation folds     \t" << nr_cv << endl;
//  			cout << "Crossvalidation method		     \t";
//  			if(cv_method==monte_carlo) cout << "random" << endl;
//  				else cout << "stratified" << endl;
//  		}
}

void Parameters::Usage()
{
    cout << "ksearch [opcje] [--static|--grow] --train file [--test file] \n\n";
    cout << "OPCJE:\n";
    cout << "  -lr N\t  --learning-rate N\n\tlearning rate - initial value (default 0.5)\n\n";
    cout << "  -rf N\t  --reward-factor N\n\treward factor  (default 0.0)\n\n";
    cout << "  -pf N\t  --penalty-factor N\n\tpenalty factor (default 0.0)\n\n";
    cout << "  -lf N\t  --lambda-factor N\n\twsp. redukujacy zmiane wag dla c=1 (default 0.0)\n\n";
    cout << "  -r N\t  --regularization N\n\tregularization  (default 0.0)\n\n";
    cout << "  -i N\t  --iterations N\n\tmaximum number of iterations (default 1000)\n\n";
    cout << "  -n N\t  --hidden-neurons N\n\tnumber of hidden nodes - initial value (default 1)\n\n";
    cout << "  -s N\t  --slope N\n\ttransfer function slope - initial value (default 2.0)\n\n";
    cout << "  --slope-learning N\tslope adaptation strategy (default 0)\n\n";
   
    cout << "  -ni N\t  --number-of-initiatializations N\n\tliczba inicjalizacji sieci (default 10)\n\n";
    cout << "  -na N\t  --number-of-attempts N\n\tliczba prob gdy nie znaleziono rozwiazania (default 3), 0=infinity\n\n";
    cout << "  --static\tstatic network, number of hidden nodes is fixed\n\n";
    cout << "  --grow\t\tconstructive network, new node is added after each training (default)\n\n";
    cout << "  --init-type [random|copy]\n\tweights initiation (default random)\n\n";
    cout << "  -input file\tfile with integer numbers - each number represent boolean functions\n";
    cout << "  -dim N\tnumber of dimensions of created data (default 0)\n\n";
    cout << "  -cv N\t --number-of-crossvalidation-folds N\n\tliczba foldow kroswalidacyjnych (default 10)\n\n";
    cout << "  --crossvalidation-method [stratified|random]	\n\t crossvalidation method (default stratified)\n\n";
    cout << "  -nt liczba\t--number-of-tests liczba\n\tnumber of test repetitions (e.g. cv or train-test) (default 10)\n\n";
    cout << " --train file\n\ttraining file\n\n";
    cout << " --test file\n\ttest file\n\n";
    cout << " --data-type [table|list]\n\tinput data representation (default table)\n\n";
     cout << "  -f [raw|snns|sca]\n\t--format [raw|snns|sca]\tformat of data file (default raw)\n\n";
     cout << " --transformation [normalization|standarization|binarization]\n\tinput data transformation (default none)\n\n";
    cout << " --input [linear|sigmoid|ssigmoid|bicentral]\n\tinput nodes typetyp (default linear)\n\n";
    cout << " --hidden [linear|sigmoid|ssigmoid|bicentral]\n\thidden nodes type (default ssigmoid)\n\n";
    cout << " --output [linear|sigmoid|ssigmoid|bicentral]\n\toutput nodes type (default linear)\n\n";
    cout << " --nhidden N\n\tilosc neuronow w pierwszej warstwie ukrytej\n\n";
    cout << " --selection\n\tusun wektory ze zbioru treningowego gdy juz nauczone\n\n";
    cout << " -H\t--hamming\n\tHamming clasterization for each node\n\n";
    cout << " --network-type [binary|knetwork|mlp]\n\tnetwork type (default binary)\n\n";
    cout << " -v|-vv|-vvv \n\tbe more verbose \n\n";
    /*
    cout << "ksearch [opcje] [--static|--grow] --train file [--test file] \n\n";
    cout << "OPCJE:\n";
    cout << "  -lr liczba\t  --learning-rate liczba\n\tpoczatkowa wartosc wsp. uczenia (default 0.5)\n\n";
    cout << "  -rf liczba\t  --reward-factor liczba\n\twsp. nagradzania za jedynki w klastrze (default 0.0)\n\n";
    cout << "  -pf liczba\t  --penalty-factor liczba\n\twsp. karzacy za zera w klastrze (default 0.0)\n\n";
    cout << "  -lf liczba\t  --lambda-factor liczba\n\twsp. redukujacy zmiane wag dla c=1 (default 0.0)\n\n";
    cout << "  -r liczba\t  --regularization liczba\n\twsp. regularyzacji (default 0.0)\n\n";
    cout << "  -i liczba\t  --iterations liczba\n\tmaksymalna liczba iteracji (default 1000)\n\n";
    cout << "  -n liczba\t  --hidden-neurons liczba\n\tpoczatkowa liczba ukrytych neuronow (default 1)\n\n";
    cout << "  -s liczba\t  --slope liczba\n\tpoczatkowa wartosc nachylenia funkcji sigmoidalnych (default 2.0)\n\n";
    cout << "  --slope-learning liczba\t strategia uczenia nachylenia (default 0)\n\n";
   
    cout << "  -ni liczba\t  --number-of-initiatializations liczba\n\tliczba inicjalizacji sieci (default 10)\n\n";
    cout << "  -na liczba\t  --number-of-attempts liczba\n\tliczba prob gdy nie znaleziono rozwiazania (default 3), 0=infinity\n\n";
    cout << "  --static\tsiec statyczna, liczba neuronow ukrytych nie zmienia sie\n";
    cout << "  --grow\t\tsiec konstruktywistyczna, dodaje neurony w trakcie uczenia (default)\n\n";
    cout << "  --init-type [random|copy]\n\tsposob inicjowania dodanych neuronow\n\n";
    cout << "  -input plik\tplik zawierajacy liczby calkowite odpowiadajace f. boolowskim\n";
    cout << "  -dim liczba\twymiar f. boolowskich czytanych z pliku (default 0)\n\n";
    cout << "  -cv liczba\t --number-of-crossvalidation-folds liczba\n\tliczba foldow kroswalidacyjnych (default 10)\n\n";
    cout << "  --crossvalidation-method [stratified|random]	\n\t metoda kroswalidacji (default stratified)\n\n";
    cout << "  -nt liczba\t--number-of-tests liczba\n\tliczba powtorzen testu (default 10)\n\n";
    cout << " --train plik\n\tplik treningowy\n\n";
    cout << " --test plik\n\tplik testowy\n\n";
    cout << " --data-type [table|list]\n\treprezentacja danych w pliku wejsciowym (default table)\n\n";
     cout << "  -f [raw|snns|sca]\n\t--format [raw|snns|sca]\tformat of data file\n\n";
     cout << " --transformation [normalization|standarization|binarization]\n\tinput data transformation (default none)\n\n";
    cout << " --input [linear|sigmoid|ssigmoid|bicentral]\n\ttyp neuronow wejsciowych (default linear)\n\n";
    cout << " --hidden [linear|sigmoid|ssigmoid|bicentral]\n\ttyp neuronow ukrytych (default ssigmoid)\n\n";
    cout << " --output [linear|sigmoid|ssigmoid|bicentral]\n\ttyp neuronow wyjsciowych (default linear)\n\n";
    cout << " --nhidden N\n\tilosc neuronow w pierwszej warstwie ukrytej\n\n";
    cout << " --selection\n\tusun wektory ze zbioru treningowego gdy juz nauczone\n\n";
    cout << " -H\t--hamming\n\tklasteryzacja HC dla kazdego z neuronow\n\n";
    cout << " --network-type [binary|knetwork|mlp]\n\trodzaj sieci (default binary) (ta opcja moze ne zawsze dzialac)\n\n";
    cout << " -v|-vv|-vvv \n\tstopien gadatliwosci programu \n\n";
*/
}

void Parameters::ReadConfigFile(char *file)
{
		
	try
	{
	
        ConfigFile config(file);
        config.readInto(learning_rate,"learning-rate",learning_rate);
        config.readInto(reward_factor,"reward-factor",reward_factor);
        config.readInto(penalty_factor,"penalty-factor",penalty_factor);
        config.readInto(lambda_factor,"lambda-factor",lambda_factor);
        config.readInto(regularization,"regularization",regularization);
        config.readInto(max_nr_of_iterations,"iterations",max_nr_of_iterations);
        config.readInto(initial_nr_of_hidden_neurons,"hidden-neurons",initial_nr_of_hidden_neurons);
        config.readInto(number_of_initiatializations,"number-of-initiatializations",number_of_initiatializations);
        config.readInto(number_of_attempts,"number-of-attemps",number_of_attempts);
        config.readInto( hidden_neurons_count,"hidden-neurons-count",hidden_neurons_count);
    
        int n=1;
        config.readInto(n,"network-architecture",n);
        if(n==1) network_architecture=grow;
        else network_architecture=static_network;
    
        config.readInto(n,"network-type",n);
        if(n==1) networkType=kNet;
	else if(n==2) networkType=MLP;
	else networkType=bNet;

        config.readInto(strategy_of_learning,"learning-strategy",strategy_of_learning);
        config.readInto(slope,"slope",slope);
        config.readInto(slope_learning,"slope-learning",slope_learning);
        config.readInto(force_zero,"force-zero",force_zero);
        config.readInto(force_one,"force-one",force_one);
        config.readInto(end_zero,"end-zero",end_zero);
        config.readInto(average,"average",average);
        config.readInto(dim,"dim",dim);
        config.readInto(nr_cv,"crossvalidation-folds",nr_cv);
        config.readInto(debug_level,"debug",debug_level);
        
        n=0;
        config.readInto(n,"crossvalidation-method",n);
        if(n) cv_method=monte_carlo;
    
        config.readInto(nr_test,"tests-number",nr_test);
        
        n=0;
        config.readInto(n,"data-type",n);
        if(n) datatype=list_of_ints;
            else datatype=table_with_labels;
        
        
        
        n=0; // 0 - lin, 1 - sigm, 2 - ssigm(magic), 3 - bicentr
        config.readInto(n,"hidden",n);
        if(n==0) hidden=linear;
        else if(n==1) hidden=sigmoid;
        else if(n==2) hidden=ssigmoid;
        else if(n==3) hidden=bicentral;
        
        n=0; // 0 - lin, 1 - sigm, 2 - ssigm(magic), 3 - bicentr
        config.readInto(n,"output",n);
        if(n==0) output=linear;
        else if(n==1) output=sigmoid;
        else if(n==2) output=ssigmoid;
        else if(n==3) output=bicentral;
        
        
        n=0; // 0 - none, 1 - normalization, 2 - standarization, 3 - binarization
        config.readInto(n,"transformation",n);
        if(n==0)      trans=none;
        else if(n==1) trans=normalization;
        else if(n==2) trans=standarization;
        else if(n==3) trans=binarization;
        
        n=0; // 0 - lin, 1 - sigm, 2 - ssigm(magic), 3 - bicentr
        config.readInto(n,"output",n);
        if(n==0) output=linear;
        else if(n==1) output=sigmoid;
        else if(n==2) output=ssigmoid;
        else if(n==3) output=bicentral;
        
        n=0;
        config.readInto(n,"init-type",n);
        if(n==0) initiation=_rand;
            else initiation=_copy;
        n=0;
        config.readInto(n,"selection",n);
        if(n) vector_selection=true;
    
        
    }catch(...)
    {
        cout << "Nie znalazlem pliku: " << file << endl;
    } 
}

